/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
package org.apache.yoko.bindings.corba;

import java.util.HashMap;
import java.util.Map;

import org.apache.yoko.wsdl.CorbaTypeImpl;

public class CorbaTypeMap {

    private String targetNamespace;
    private String prefix;
    private Map<String, CorbaTypeImpl> typeMap;

    public CorbaTypeMap(String namespace) {
        targetNamespace = namespace;
        typeMap = new HashMap<String, CorbaTypeImpl>();
    }

    public void addType(String name, CorbaTypeImpl type) {
        typeMap.put(name, type);
    }

    public CorbaTypeImpl getType(String name) {
        assert name != null;

        return typeMap.get(name);
    }

    public String getTargetNamespace() {
        return targetNamespace;
    }

    public void setPrefix(String pfx) {
        prefix = pfx;
    }

    public String getPrefix() {
        return prefix;
    }
}
