/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements. See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership. The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied. See the License for the
 * specific language governing permissions and limitations
 * under the License.
*/

package org.apache.schemas.yoko.idl.parammodes;

import javax.xml.bind.annotation.XmlRegistry;


/**
 * This object contains factory methods for each 
 * Java content interface and Java element interface 
 * generated in the org.apache.schemas.yoko.idl.parammodes package. 
 * <p>An ObjectFactory allows you to programatically 
 * construct new instances of the Java representation 
 * for XML content. The Java representation of XML 
 * content can consist of schema derived interfaces 
 * and classes representing the binding of schema 
 * type definitions, element declarations and model 
 * groups.  Factory methods for each of these are 
 * provided in this class.
 * 
 */
@XmlRegistry
public class ObjectFactory {


    /**
     * Create a new ObjectFactory that can be used to create new instances of schema derived classes for package: org.apache.schemas.yoko.idl.parammodes
     * 
     */
    public ObjectFactory() {
    }

    /**
     * Create an instance of {@link TestReturnResponse }
     * 
     */
    public TestReturnResponse createTestReturnResponse() {
        return new TestReturnResponse();
    }

    /**
     * Create an instance of {@link TestSingleOutParam }
     * 
     */
    public TestSingleOutParam createTestSingleOutParam() {
        return new TestSingleOutParam();
    }

    /**
     * Create an instance of {@link TestSingleOutParamResponse }
     * 
     */
    public TestSingleOutParamResponse createTestSingleOutParamResponse() {
        return new TestSingleOutParamResponse();
    }

    /**
     * Create an instance of {@link TestSingleInParam }
     * 
     */
    public TestSingleInParam createTestSingleInParam() {
        return new TestSingleInParam();
    }

    /**
     * Create an instance of {@link TestMultipleOutParamsWithReturn }
     * 
     */
    public TestMultipleOutParamsWithReturn createTestMultipleOutParamsWithReturn() {
        return new TestMultipleOutParamsWithReturn();
    }

    /**
     * Create an instance of {@link TestSingleInParamWithReturnResponse }
     * 
     */
    public TestSingleInParamWithReturnResponse createTestSingleInParamWithReturnResponse() {
        return new TestSingleInParamWithReturnResponse();
    }

    /**
     * Create an instance of {@link TestMultipleInParamsWithReturnResponse }
     * 
     */
    public TestMultipleInParamsWithReturnResponse createTestMultipleInParamsWithReturnResponse() {
        return new TestMultipleInParamsWithReturnResponse();
    }

    /**
     * Create an instance of {@link TestMultipleMixedParamsWithReturn }
     * 
     */
    public TestMultipleMixedParamsWithReturn createTestMultipleMixedParamsWithReturn() {
        return new TestMultipleMixedParamsWithReturn();
    }

    /**
     * Create an instance of {@link TestMultipleOutParamsWithReturnResponse }
     * 
     */
    public TestMultipleOutParamsWithReturnResponse createTestMultipleOutParamsWithReturnResponse() {
        return new TestMultipleOutParamsWithReturnResponse();
    }

    /**
     * Create an instance of {@link TestSingleInOutParamWithReturnResponse }
     * 
     */
    public TestSingleInOutParamWithReturnResponse createTestSingleInOutParamWithReturnResponse() {
        return new TestSingleInOutParamWithReturnResponse();
    }

    /**
     * Create an instance of {@link TestMultipleMixedParamsResponse }
     * 
     */
    public TestMultipleMixedParamsResponse createTestMultipleMixedParamsResponse() {
        return new TestMultipleMixedParamsResponse();
    }

    /**
     * Create an instance of {@link TestMultipleInOutParams }
     * 
     */
    public TestMultipleInOutParams createTestMultipleInOutParams() {
        return new TestMultipleInOutParams();
    }

    /**
     * Create an instance of {@link TestSingleInParamResponse }
     * 
     */
    public TestSingleInParamResponse createTestSingleInParamResponse() {
        return new TestSingleInParamResponse();
    }

    /**
     * Create an instance of {@link TestSingleInOutParamWithReturn }
     * 
     */
    public TestSingleInOutParamWithReturn createTestSingleInOutParamWithReturn() {
        return new TestSingleInOutParamWithReturn();
    }

    /**
     * Create an instance of {@link TestMultipleInOutParamsResponse }
     * 
     */
    public TestMultipleInOutParamsResponse createTestMultipleInOutParamsResponse() {
        return new TestMultipleInOutParamsResponse();
    }

    /**
     * Create an instance of {@link TestMultipleOutParams }
     * 
     */
    public TestMultipleOutParams createTestMultipleOutParams() {
        return new TestMultipleOutParams();
    }

    /**
     * Create an instance of {@link TestSingleInOutParam }
     * 
     */
    public TestSingleInOutParam createTestSingleInOutParam() {
        return new TestSingleInOutParam();
    }

    /**
     * Create an instance of {@link TestSingleInOutParamResponse }
     * 
     */
    public TestSingleInOutParamResponse createTestSingleInOutParamResponse() {
        return new TestSingleInOutParamResponse();
    }

    /**
     * Create an instance of {@link TestMultipleInParamsResponse }
     * 
     */
    public TestMultipleInParamsResponse createTestMultipleInParamsResponse() {
        return new TestMultipleInParamsResponse();
    }

    /**
     * Create an instance of {@link TestMultipleMixedParams }
     * 
     */
    public TestMultipleMixedParams createTestMultipleMixedParams() {
        return new TestMultipleMixedParams();
    }

    /**
     * Create an instance of {@link TestMultipleInOutParamsWithReturn }
     * 
     */
    public TestMultipleInOutParamsWithReturn createTestMultipleInOutParamsWithReturn() {
        return new TestMultipleInOutParamsWithReturn();
    }

    /**
     * Create an instance of {@link TestSingleInParamWithReturn }
     * 
     */
    public TestSingleInParamWithReturn createTestSingleInParamWithReturn() {
        return new TestSingleInParamWithReturn();
    }

    /**
     * Create an instance of {@link TestMultipleInParams }
     * 
     */
    public TestMultipleInParams createTestMultipleInParams() {
        return new TestMultipleInParams();
    }

    /**
     * Create an instance of {@link TestSingleOutParamWithReturn }
     * 
     */
    public TestSingleOutParamWithReturn createTestSingleOutParamWithReturn() {
        return new TestSingleOutParamWithReturn();
    }

    /**
     * Create an instance of {@link TestMultipleMixedParamsWithReturnResponse }
     * 
     */
    public TestMultipleMixedParamsWithReturnResponse createTestMultipleMixedParamsWithReturnResponse() {
        return new TestMultipleMixedParamsWithReturnResponse();
    }

    /**
     * Create an instance of {@link TestMultipleInOutParamsWithReturnResponse }
     * 
     */
    public TestMultipleInOutParamsWithReturnResponse createTestMultipleInOutParamsWithReturnResponse() {
        return new TestMultipleInOutParamsWithReturnResponse();
    }

    /**
     * Create an instance of {@link TestReturn }
     * 
     */
    public TestReturn createTestReturn() {
        return new TestReturn();
    }

    /**
     * Create an instance of {@link TestMultipleInParamsWithReturn }
     * 
     */
    public TestMultipleInParamsWithReturn createTestMultipleInParamsWithReturn() {
        return new TestMultipleInParamsWithReturn();
    }

    /**
     * Create an instance of {@link TestSingleOutParamWithReturnResponse }
     * 
     */
    public TestSingleOutParamWithReturnResponse createTestSingleOutParamWithReturnResponse() {
        return new TestSingleOutParamWithReturnResponse();
    }

    /**
     * Create an instance of {@link TestMultipleOutParamsResponse }
     * 
     */
    public TestMultipleOutParamsResponse createTestMultipleOutParamsResponse() {
        return new TestMultipleOutParamsResponse();
    }

}
