@rem Licensed under the Apache License, Version 2.0 (the "License");
@rem you may not use this file except in compliance with the License.
@rem You may obtain a copy of the License at
@rem 
@rem     http://www.apache.org/licenses/LICENSE-2.0
@rem 
@rem Unless required by applicable law or agreed to in writing, software
@rem distributed under the License is distributed on an "AS IS" BASIS,
@rem WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
@rem See the License for the specific language governing permissions and
@rem limitations under the License.

@echo off

if "%1" == "" goto USAGE
if not EXIST %1 goto ERROR
if not EXIST %1/lib goto ERROR

call mvn install:install-file -DgroupId=javax.annotation  -DartifactId=jsr250-api -Dversion=2.0-JAXWS-2.0-EA3 -Dpackaging=jar -DgeneratePom=true -Dfile=%1/lib/jsr250-api.jar
call mvn install:install-file -DgroupId=javax.jws  -DartifactId=jsr181-api -Dversion=2.0-JAXWS-2.0-EA3 -Dpackaging=jar -DgeneratePom=true -Dfile=%1/lib/jsr181-api.jar
call mvn install:install-file -DgroupId=javax.activation  -DartifactId=activation -Dversion=1.0.2 -Dpackaging=jar -DgeneratePom=true -Dfile=%1/lib/activation.jar
call mvn install:install-file -DgroupId=javax.xml  -DartifactId=jaxws-api -Dversion=2.0-JAXWS-2.0-EA3 -Dpackaging=jar -DgeneratePom=true -Dfile=%1/lib/jaxws-api.jar
call mvn install:install-file -DgroupId=javax.xml  -DartifactId=jaxb-api -Dversion=2.0-JAXWS-2.0-EA3 -Dpackaging=jar -DgeneratePom=true -Dfile=%1/lib/jaxb-api.jar
call mvn install:install-file -DgroupId=javax.xml  -DartifactId=saaj-api -Dversion=1.3 -Dpackaging=jar -DgeneratePom=true -Dfile=%1/lib/saaj-api.jar

call mvn install:install-file -DgroupId=com.sun.xml  -DartifactId=jaxb-xjc -Dversion=2.0-JAXWS-2.0-EA3 -Dpackaging=jar -DgeneratePom=true -Dfile=%1/lib/jaxb-xjc.jar
call mvn install:install-file -DgroupId=com.sun.xml  -DartifactId=jaxb-impl -Dversion=2.0-JAXWS-2.0-EA3 -Dpackaging=jar -DgeneratePom=true -Dfile=%1/lib/jaxb-impl.jar
call mvn install:install-file -DgroupId=com.sun.xml  -DartifactId=saaj-impl -Dversion=1.3 -Dpackaging=jar -DgeneratePom=true -Dfile=%1/lib/saaj-impl.jar
echo SUCCESS: Installation is complete
goto END

:ERROR
	echo ERROR: Specified directory is not found or valid!!!

:USAGE
        echo You must specify the directory of your JAX-WS RI2.0 Early Access 3 install.
        echo It can be downloaded from https://jax-ws.dev.java.net/jax-ws-ea3/jaxws20ea3.jar
        echo example:   installSunJars.bat C:\jaxws-ri
        
:END

